#include "ZBLrender.h"
#include "render.h"
#include <GL/glew.h>
#include <memory.h>

CKosRender::CKosRender(int w, int h)
{
	width = w;
	height = h;
	buffer = new RGB[width * height];
	memset(buffer, 0, width*height*sizeof(RGB));
}

CKosRender::~CKosRender(void)
{
	delete [] buffer;
}

void CKosRender::Draw(Point position)
{
    glBindTexture(GL_TEXTURE_2D, render::target);
    glTexSubImage2D(GL_TEXTURE_2D, position.Y, position.X, 0, width, height, GL_BGR, GL_UNSIGNED_BYTE, this->buffer);
	kos_PutImage((RGB*)this->buffer, width, height, position.Y, position.X);
}

void CKosRender::RenderImg(RGB *img, Point position, int width, int height)
{
	for (int y = position.Y; y < position.Y + height; y++)
		for (int x = position.X; x < position.X + width; x++)
			if (x >= 0 && y >= 0 && x < this->width && y < this->height)
				this->buffer[y * this->width + x] = img[(y - position.Y) * width + (x - position.X)];
}

int CKosRender::getPixel(int x, int y)
{
	return y * this->width + x;
}
