#include <GLFW/glfw3.h>
#include <string.h>
#include "render.h"

GLuint render::target;

RGB buffer[384*384];


void kos_PutImage(RGB *img, int x1, int y1, int x2, int y2)
{
    int w = x1, h = y1;
    for(int i = 0; i < h; i++)
        for(int j = 0; j < w; j++)
            buffer[(i+x2)*384+(j+y2)] = img[i*w+j];
}

void render::start()
{
    glClear(GL_COLOR_BUFFER_BIT);
    glLoadIdentity();
    glOrtho(0, 384, 384, 0, -1, 1);
    glViewport(0, 0, 384, 384);
}

void render::end()
{
    glBindTexture(GL_TEXTURE_2D, target);
    glEnable(GL_TEXTURE_2D);
    glTexSubImage2D(GL_TEXTURE_2D, 0, 0, 0, 384, 384, 0x80e0, GL_UNSIGNED_BYTE, buffer);

    const float offset[4][2] = {0, 0, 0, 1, 1, 1, 1, 0};
    glBegin(GL_QUADS);
        for(int i = 0; i < 4; i++)
        {
            glTexCoord2f(offset[i][0], offset[3-i][1]);
            glVertex2f(384*offset[i][0], 384*offset[i][1]);
        }
    glEnd();
}

void render::init()
{
    glGenTextures(1, &target);

    glBindTexture(GL_TEXTURE_2D, target);
    glTexImage2D(GL_TEXTURE_2D, 0, GL_RGB, 384, 384, 0, GL_RGB, GL_UNSIGNED_BYTE, 0);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
    glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
}

void render::close()
{
    glBindTexture(GL_TEXTURE_2D, 0);
    glDeleteTextures(1, &target);
}
